Index: /cpp/frams/model/similarity/measure-greedy.h
===================================================================
--- /cpp/frams/model/similarity/measure-greedy.h	(revision 1044)
+++ /cpp/frams/model/similarity/measure-greedy.h	(revision 1044)
@@ -0,0 +1,141 @@
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
+
+#ifndef _GREEDY_MEASURE_H
+#define _GREEDY_MEASURE_H
+
+#include "measure-mds-based.h"
+#include "frams/genetics/geno.h"
+#include "frams/model/model.h"
+#include "simil-match.h"
+#include "measure-greedy.h"
+
+#define TDN_SIZE 5
+
+
+enum TDNELEMS2
+{
+	ORG_IND = 0,
+	DEG = 1,
+	NEUR_CONNS = 2,
+	NEUROS = 3,
+	FUZ_DEG = 4
+};
+
+class SimilMeasureGreedy : public SimilMeasureMDSBased
+{
+public:
+	SimilMeasureGreedy();
+	~SimilMeasureGreedy(){};
+
+	static int compareDegrees(const void *pElem1, const void *pElem2);
+	static int compareFuzzyDegrees(const void *pElem1, const void *pElem2);
+	static int compareConnsNo(const void *pElem1, const void *pElem2);
+	static int getNOFactors();
+	int setParams(std::vector<double> params);
+	/// Interface to local parameters
+	Param localpar;
+	/// Table of weights for weighted distance function.
+	/// Weights are for factors in the following order:
+	/// [0]: m_iDV (difference in the number of vertices)
+	/// [1]: m_iDD (difference in degrees over matching)
+	/// [2]: m_iDN (difference in neurons over matching)
+	/// [3]: m_dDG (difference in geometry over matching)
+	/// @sa EvaluateDistance
+	double m_adFactors[4];
+
+	//Controls the depth of fuzzy neighbourhood 
+	int fuzzyDepth;
+	bool isFuzzy;
+
+protected:
+	double distanceForTransformation();
+	double distanceWithoutAlignment();
+	void prepareData();
+	void beforeTransformation();
+	void computeMatching();
+	void copyMatching();
+	void cleanData();
+
+	int sortPartInfoTables();
+	int countPartNeurons();
+	int countPartDegrees();
+	int countPartsDistance();
+
+	void countFuzzyNeighb();
+	void sortFuzzyNeighb();
+	void getNeighbIndexes(int mod, int partInd, std::vector<int> &indexes);
+	void fuzzyOrder();
+	int createPartInfoTables();
+	
+	void _PrintArray(int *array, int base, int size);
+	void _PrintArrayDouble(double *array, int base, int size);
+	void _PrintDegrees(int i);
+	void _PrintNeighbourhood(int i);
+	void _PrintFuzzyNeighbourhood(int i);
+	void _PrintSeamnessTable(std::vector<int> *pVector, int iCount);
+	void _PrintPartsMatching();
+	void saveIntermediateFiles();
+
+	/// Number of parts of two creatures (index the same as for m_Mod).
+	int m_aiPartCount[2];
+
+	/// Difference between number of parts in organisms
+	int m_iDV;
+
+	/// Sum of absolute values of differences between matched part degrees
+	int m_iDD;
+
+	/// Sum of absolute values of differences between matched part 
+	/// in neurons number.
+	int m_iDN;
+	//2 matrices of neighbourhood of parts - one for each genotype 
+
+	/// Sum of Euclidean distances between matched parts
+	/// Unmatched Parts have the distance measured to (0,0,0) (the middle of
+	/// an organism)
+	double m_dDG;
+
+	/// Object that holds the matching of Parts.
+	SimilMatching *m_pMatching;
+	/// Object that holds temporary matching of Parts.
+	SimilMatching *tempMatching;
+
+	/// Type of 4 ints - describing one Part of the creature in
+	/// its sorted table of degrees
+	/// TDN[0] - original index of creature's Part (that is "i" from GetPart(i))
+	/// TDN[1] - degree (number of adjacent joints) of one Part
+	/// TDN[2] - number of NeuroConnections and Neurons belonging to one Part
+	/// TDN[3] - number of Neurons of the Part
+	/// TDN[4] - fuzzy degree
+	typedef int TDN[5];
+
+	/** 2 arrays holding information about compared organisms (one for each
+	creature) of degree and neuro info for Parts.
+	Index corresponds to the one in m_Mod
+	m_aDegrees[i][j] is a TDN of the j-th Part of the i-th creature in m_Mod
+	*/
+	TDN *m_aDegrees[2];
+
+	//std::pair<TDN, double> *m_aDegrees[2];
+	/// Holds information on all on-joint neurons. Only TDN[3] and TDN[4]
+	/// are important (original index and degree are not important).
+	TDN m_aOnJoint[2];
+
+	/// Holds information on all neurons that are not placed neither on
+	/// a joint nor on a part. Only TDN[3] and TDN[4]
+	/// are important (original index and degree are not important).
+	TDN m_aAnywhere[2];
+
+	//array of parts neighbourhood
+	int **m_Neighbours[2];
+	//array of "fuzzy neigbourhood" for each of organisms. Dimensions: parts_num x fuzzyDepth
+	float **m_fuzzyNeighb[2];
+
+	/// Number of weights in the function which evaluates distance.
+	static const int iNOFactors; 
+};
+
+#endif /* GREEDY_MEASURE_H */
+
Index: /cpp/frams/model/similarity/measure-hungarian.cpp
===================================================================
--- /cpp/frams/model/similarity/measure-hungarian.cpp	(revision 1044)
+++ /cpp/frams/model/similarity/measure-hungarian.cpp	(revision 1044)
@@ -0,0 +1,228 @@
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
+
+#include "measure-hungarian.h"
+
+const int SimilMeasureHungarian::iNOFactors = 4;
+
+#define FIELDSTRUCT SimilMeasureHungarian
+
+static ParamEntry simil_hungarian_paramtab[] = {
+		{ "Similarity: hungarian", 1, 7, "similHungarianMeasure", "Evaluates morphological dissimilarity using hungarian measure. More information:\nhttp://www.framsticks.com/bib/Komosinski-et-al-2001\nhttp://www.framsticks.com/bib/Komosinski-and-Kubiak-2011\nhttp://www.framsticks.com/bib/Komosinski-2016\nhttps://doi.org/10.1007/978-3-030-16692-2_8", },
+		{ "simil_parts", 0, 0, "Weight of parts count", "f 0 100 0", FIELD(m_adFactors[0]), "Differing number of parts is also handled by the 'part degree' similarity component.", },
+		{ "simil_partdeg", 0, 0, "Weight of parts' degree", "f 0 100 1", FIELD(m_adFactors[1]), "", },
+		{ "simil_neuro", 0, 0, "Weight of neurons count", "f 0 100 0.1", FIELD(m_adFactors[2]), "", },
+		{ "simil_partgeom", 0, 0, "Weight of parts' geometric distances", "f 0 100 0", FIELD(m_adFactors[3]), "", },
+		{ "simil_fixedZaxis", 0, 0, "Fix 'z' (vertical) axis?", "d 0 1 0", FIELD(fixedZaxis), "", },
+		{ "simil_weightedMDS", 0, 0, "Should weighted MDS be used?", "d 0 1 0", FIELD(wMDS), "If activated, weighted MDS with vertex (i.e., Part) degrees as weights is used for 3D alignment of body structure.", },
+		{ "evaluateDistance", 0, PARAM_DONTSAVE | PARAM_USERHIDDEN, "evaluate model dissimilarity", "p f(oGeno,oGeno)", PROCEDURE(p_evaldistance), "Calculates dissimilarity between two models created from Geno objects.", },
+		{ 0, },
+};
+
+#undef FIELDSTRUCT
+
+SimilMeasureHungarian::SimilMeasureHungarian() : localpar(simil_hungarian_paramtab, this)
+{
+	localpar.setDefault();
+	
+	nSmaller = 0;
+	nBigger = 0;
+	
+	for (int i = 0; i < 2; i++)
+	{
+		degrees[i] = nullptr;
+		neurons[i] = nullptr;
+		on_joint[i] = 0;
+		anywhere[i] = 0;	
+	}
+	
+	assignment = nullptr;
+	parts_distances = nullptr;
+	temp_parts_distances = nullptr;
+	
+	save_matching = false;
+}
+
+void SimilMeasureHungarian::prepareData()
+{
+	m_iSmaller = models[0]->getPartCount() <= models[1]->getPartCount() ? 0 : 1;
+	nSmaller = models[m_iSmaller]->getPartCount();
+	nBigger = models[1 - m_iSmaller]->getPartCount();
+
+	for (int i = 0; i < 2; i++)
+	{
+		int size = models[i]->getPartCount();
+		degrees[i] = new int[size]();
+		neurons[i] = new int[size]();
+	}
+	
+	countDegrees();
+	countNeurons();
+	
+	parts_distances = new double[nBigger*nBigger]();
+	fillPartsDistances(parts_distances, nBigger, nSmaller, false);
+	assignment = new int[nBigger]();
+	
+	if (save_matching)
+		for (int i = 0; i < nBigger; i++)
+			min_assignment.push_back(0);
+}
+
+void SimilMeasureHungarian::beforeTransformation()
+{
+	temp_parts_distances = new double[nBigger*nBigger]();
+	std::copy(parts_distances, parts_distances + nBigger * nBigger, temp_parts_distances);
+}
+
+double SimilMeasureHungarian::distanceForTransformation()
+{
+	fillPartsDistances(temp_parts_distances, nBigger, nSmaller, true);
+	std::fill_n(assignment, nBigger, 0);
+	double distance = hungarian.Solve(temp_parts_distances, assignment, nBigger, nBigger);
+
+	delete[] temp_parts_distances;
+	return addNeuronsPartsDiff(distance);
+}
+
+double SimilMeasureHungarian::distanceWithoutAlignment()
+{
+	double distance = hungarian.Solve(parts_distances, assignment, nBigger, nBigger);
+	if (save_matching)
+		copyMatching();
+	return addNeuronsPartsDiff(distance);
+}
+
+double SimilMeasureHungarian::addNeuronsPartsDiff(double dist)
+{
+	//add difference in anywhere and onJoint neurons
+	dist += m_adFactors[2] * (abs(on_joint[0] - on_joint[1]) + abs(anywhere[0] - anywhere[1]));
+	//add difference in part numbers
+	dist += (nBigger - nSmaller) * m_adFactors[0];
+	return dist;
+}
+
+void SimilMeasureHungarian::copyMatching()
+{
+	min_assignment.clear();
+	min_assignment.insert(min_assignment.begin(), assignment, assignment + nBigger);
+}
+
+void SimilMeasureHungarian::cleanData()
+{
+	for (int i = 0; i < 2; i++)
+	{
+		// delete degree and position arrays
+		SAFEDELETEARRAY(degrees[i]);
+		SAFEDELETEARRAY(neurons[i]);	
+
+		on_joint[i] = 0;
+		anywhere[i] = 0;	
+	}
+
+	delete[] assignment;
+	delete[] parts_distances;
+	
+	if (save_matching)
+		min_assignment.clear();
+}
+
+void SimilMeasureHungarian::countDegrees()
+{
+	Part *P1, *P2;
+	int i, j, i1, i2;
+
+	for (i = 0; i < 2; i++)
+	{
+		for (j = 0; j < models[i]->getJointCount(); j++)
+		{
+			Joint *J = models[i]->getJoint(j);
+
+			P1 = J->part1;
+			P2 = J->part2;
+
+			i1 = models[i]->findPart(P1);
+			i2 = models[i]->findPart(P2);
+
+			degrees[i][i1]++;
+			degrees[i][i2]++;
+		}
+	}
+}
+
+void SimilMeasureHungarian::countNeurons()
+{
+	Part *P1;
+	Joint *J1;
+	int i, j, i2;
+
+	for (i = 0; i < 2; i++)
+	{
+		for (j = 0; j < models[i]->getNeuroCount(); j++)
+		{
+			Neuro *N = models[i]->getNeuro(j);
+			// count parts attached to neurons
+			P1 = N->getPart();
+			if (P1)
+			{
+				i2 = models[i]->findPart(P1);
+				neurons[i][i2]++;
+			}
+			else
+			// count unattached neurons
+			{
+				J1 = N->getJoint();
+				if (J1)
+					on_joint[i]++;
+				else
+					anywhere[i]++;
+			}
+		}
+	}
+}
+
+void SimilMeasureHungarian::fillPartsDistances(double*& dist, int bigger, int smaller, bool geo)
+{
+	for (int i = 0; i < bigger; i++)
+	{
+		for (int j = 0; j < bigger; j++)
+		{
+			// assign penalty for unassignment for vertex from bigger model
+			if (j >= smaller)
+			{
+				if (geo)
+					dist[i*bigger + j] += m_adFactors[3] * coordinates[1 - m_iSmaller][i].length();
+				else
+					dist[i*bigger + j] = m_adFactors[1] * degrees[1 - m_iSmaller][i] + m_adFactors[2] * neurons[1 - m_iSmaller][i];
+			}
+			// compute distance between parts
+			else
+			{
+				if (geo){
+					dist[i*bigger + j] += m_adFactors[3] * coordinates[1 - m_iSmaller][i].distanceTo(coordinates[m_iSmaller][j]);
+	}
+				else
+					dist[i*bigger + j] = m_adFactors[1] * abs(degrees[1 - m_iSmaller][i] - degrees[m_iSmaller][j])
+					+ m_adFactors[2] * abs(neurons[1 - m_iSmaller][i] - neurons[m_iSmaller][j]);
+			}
+		}
+	}
+}
+
+/** Returns number of factors involved in final distance computation.
+		These factors include differences in numbers of parts, degrees,
+		number of neurons.
+		*/
+int SimilMeasureHungarian::getNOFactors()
+{
+	return SimilMeasureHungarian::iNOFactors;
+}
+
+int SimilMeasureHungarian::setParams(std::vector<double> params)
+{
+	int i = 0;
+	for (i = 0; i < SimilMeasureHungarian::iNOFactors; i++)
+		m_adFactors[i] = params.at(i);
+	fixedZaxis = params.at(i);
+	return 0;
+}
Index: /cpp/frams/model/similarity/measure-hungarian.h
===================================================================
--- /cpp/frams/model/similarity/measure-hungarian.h	(revision 1044)
+++ /cpp/frams/model/similarity/measure-hungarian.h	(revision 1044)
@@ -0,0 +1,78 @@
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
+
+#ifndef HUNGARIAN_MEASURE_H
+#define HUNGARIAN_MEASURE_H
+
+#include "measure-mds-based.h"
+#include "frams/genetics/geno.h"
+#include "frams/model/model.h"
+#include "hungarian/hungarian.h"
+
+class SimilMeasureHungarian : public SimilMeasureMDSBased
+{
+public:
+	SimilMeasureHungarian();
+	~SimilMeasureHungarian(){};
+	
+	double distanceForTransformation();
+	double distanceWithoutAlignment();
+	
+	static int getNOFactors();
+	int setParams(std::vector<double> params);
+
+	/// Table of weights for weighted distance function.
+	/// Weights are for factors in the following order:
+	/// [0]: m_iDV (difference in the number of vertices)
+	/// [1]: m_iDD (difference in degrees over matching)
+	/// [2]: m_iDN (difference in neurons over matching)
+	/// [3]: m_dDG (difference in geometry over matching)
+	/// @sa EvaluateDistance
+	double m_adFactors[4];
+	
+	/// Interface to local parameters
+	Param localpar;
+
+protected:
+	void prepareData();
+	void beforeTransformation();
+	void copyMatching();
+	void cleanData();
+	
+	void countDegrees();
+	void countNeurons();
+	void fillPartsDistances(double*& dist, int bigger, int smaller, bool geo);
+	double addNeuronsPartsDiff(double dist);
+	
+	//Smaller and greater structures sizes
+	int nSmaller;
+	int nBigger;
+	
+	//Vertex degrees for both structures
+	int *degrees[2];
+	
+	//Count of neurons attached to each parts for both structures
+	int *neurons[2];
+	
+	//Number of on-joint and unattached neurons for both structures
+	int on_joint[2];
+	int anywhere[2];
+	
+	//Temporary and final assignment
+	int *assignment;
+	std::vector<int> min_assignment;
+	
+	//Final and temporary parts distances
+	double* parts_distances;
+	double* temp_parts_distances;
+	
+	HungarianAlgorithm hungarian;
+	
+	/// Number of weights in the function which evaluates distance.
+	static const int iNOFactors;
+};
+
+
+#endif /* HUNGARIAN_MEASURE_H */
+
Index: /cpp/frams/model/similarity/measure-mds-based.cpp
===================================================================
--- /cpp/frams/model/similarity/measure-mds-based.cpp	(revision 1044)
+++ /cpp/frams/model/similarity/measure-mds-based.cpp	(revision 1044)
@@ -0,0 +1,213 @@
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
+
+#include "measure-mds-based.h"
+#include "SVD/matrix_tools.h"
+
+SimilMeasureMDSBased::SimilMeasureMDSBased()
+{
+	coordinates[0] = nullptr;
+	coordinates[1] = nullptr;
+	
+	with_alignment = true;
+	save_matching = false;
+	fixedZaxis = 0;
+	wMDS = 1;
+}
+
+double SimilMeasureMDSBased::getDistance()
+{
+	double dResult = -1;
+	m_iSmaller = models[0]->getPartCount() <= models[1]->getPartCount() ? 0 : 1;
+
+	prepareData();
+	
+	if (with_alignment)
+	{
+		if (!getPartPositions())
+		{
+			logPrintf("SimilMDSBasedMeasure", "getDistance", LOG_ERROR, "Cannot compute part positions");
+			return -1;
+		}
+		
+		if (!computePartsPositionsByMDS())
+		{
+			logPrintf("SimilMDSBasedMeasure", "getDistance", LOG_ERROR, "Cannot perform MDS");
+			return -1;
+		}
+
+		// tutaj zacznij pętlę po przekształceniach  geometrycznych
+		const int NO_OF_TRANSFORM = 8; // liczba transformacji geometrycznych (na razie tylko ID i O_YZ)
+		// tablice transformacji współrzędnych; nie są to dokładnie tablice tranformacji, ale raczej tablice PRZEJŚĆ
+		// pomiędzy transformacjami; 
+		const int dMulX[NO_OF_TRANSFORM] = { 1, -1, -1, 1, -1, 1, -1, -1 };
+		const int dMulY[NO_OF_TRANSFORM] = { 1, 1, -1, -1, -1, -1, -1, 1 };
+		const int dMulZ[NO_OF_TRANSFORM] = { 1, 1, 1, -1, -1, -1, 1, 1 };
+
+		#ifdef max
+		#undef max //this macro would conflict with line below
+		#endif
+		double dMinSimValue = std::numeric_limits<double>::max(); // minimum value of similarity
+		
+		int iTransform; // a counter of geometric transformations
+		for (iTransform = 0; iTransform < NO_OF_TRANSFORM; iTransform++)
+		{
+			beforeTransformation();
+			
+			for (int iPart = 0; iPart < models[m_iSmaller]->getPartCount(); iPart++)
+			{
+				// for each iPart, a part of the model iMod
+				coordinates[m_iSmaller][iPart].x *= dMulX[iTransform];
+				coordinates[m_iSmaller][iPart].y *= dMulY[iTransform];
+				coordinates[m_iSmaller][iPart].z *= dMulZ[iTransform];
+			}
+			// now the positions are recomputed
+			double dCurrentSim = distanceForTransformation();
+
+			// załóż poprawną wartość podobieństwa
+			assert(dCurrentSim >= 0.0);
+
+			// porównaj wartość obliczoną z dotychczasowym minimum
+			if (dCurrentSim < dMinSimValue)
+			{
+			//printf("lesser sim\n");
+				dMinSimValue = dCurrentSim;
+				if (save_matching)
+					copyMatching();
+			}
+		}
+		
+		dResult = dMinSimValue;
+		
+		SAFEDELETEARRAY(coordinates[0]);
+		SAFEDELETEARRAY(coordinates[1]);
+	}
+	else
+	{
+		dResult = distanceWithoutAlignment();
+	}
+
+	cleanData();
+
+	return dResult;
+}
+
+
+/** Gets information about Parts' positions in 3D from models into the arrays
+		coordinates.
+		Assumptions:
+		- Models (models) are created and available.
+		- Arrays coordinates are created.
+		@return 1 if success, otherwise 0.
+		*/
+int SimilMeasureMDSBased::getPartPositions()
+{	
+	// for each model copy its part coordinates
+	Part *pPart;
+	for (int iMod = 0; iMod < 2; iMod++)
+	{
+		// utworz tablice dla pozycji 3D Parts (wielkosc tablicy: liczba Parts organizmu)
+		coordinates[iMod] = new Pt3D[models[iMod]->getPartCount()];
+		assert(coordinates[iMod] != NULL);
+		// dla każdego z modeli iMod
+		for (int iPart = 0; iPart < models[iMod]->getPartCount(); iPart++)
+		{
+			// dla każdego iPart organizmu iMod
+			// pobierz tego Part
+			pPart = models[iMod]->getPart(iPart);
+			// zapamietaj jego pozycje 3D w tablicy coordinates
+			coordinates[iMod][iPart].x = pPart->p.x;
+			coordinates[iMod][iPart].y = pPart->p.y;
+			coordinates[iMod][iPart].z = pPart->p.z;
+		}
+	}
+
+	return 1;
+}
+
+bool SimilMeasureMDSBased::computePartsPositionsByMDS()
+{
+	bool bResult = true;
+	
+	// use MDS to obtain different point of view on organisms
+	// and store the new positions (currently the original ones are still stored)
+	for (int iMod = 0; iMod < 2; iMod++)
+	{
+		// prepare the vector of errors of approximation for the SVD
+		std::vector<double> vEigenvalues;
+		int nSize = models[iMod]->getPartCount();
+
+		double *pDistances = new double[nSize * nSize];
+
+		for (int i = 0; i < nSize; i++)
+		{
+			pDistances[i] = 0;
+		}
+
+		Model *pModel = models[iMod]; // use the model of the iMod (current) organism
+		int iP1, iP2; // indices of Parts in the model
+		Part *P1, *P2; // pointers to Parts
+		Pt3D P1Pos, P2Pos; // positions of parts 
+		double dDistance; // the distance between Parts
+
+		double *weights = new double[nSize];
+		for (int i = 0; i < nSize; i++)
+		{
+			if (wMDS == 1)
+				weights[i] = 0;
+			else
+				weights[i] = 1;
+		}
+
+		if (wMDS == 1)
+			for (int i = 0; i < pModel->getJointCount(); i++)
+			{
+				weights[pModel->getJoint(i)->p1_refno]++;
+				weights[pModel->getJoint(i)->p2_refno]++;
+			}
+
+		for (iP1 = 0; iP1 < pModel->getPartCount(); iP1++)
+		{
+			// for each iP1, a Part index in the model of organism iMod
+			P1 = pModel->getPart(iP1);
+			// get the position of the Part
+			P1Pos = P1->p;
+			if (fixedZaxis == 1)
+			{
+				P1Pos.z = 0; //fixed vertical axis, so pretend all points are on the xy plane
+			}
+			for (iP2 = 0; iP2 < pModel->getPartCount(); iP2++)
+			{
+				// for each (iP1, iP2), a pair of Parts index in the model
+				P2 = pModel->getPart(iP2);
+				// get the position of the Part
+				P2Pos = P2->p;
+				if (fixedZaxis == 1)
+				{
+					P2Pos.z = 0; //fixed vertical axis, so pretend all points are on the xy plane
+				}
+				// compute the geometric (Euclidean) distance between the Parts
+				dDistance = P1Pos.distanceTo(P2Pos);
+				// store the distance
+				pDistances[iP1 * nSize + iP2] = dDistance;
+			} // for (iP2)
+		} // for (iP1)
+		
+		MatrixTools::weightedMDS(vEigenvalues, nSize, pDistances, coordinates[iMod], weights);
+		
+		if (fixedZaxis == 1) //restore the original vertical coordinate of each Part
+		{
+			for (int part = 0; part < pModel->getPartCount(); part++)
+			{
+				coordinates[iMod][part].z = pModel->getPart(part)->p.z;
+			}
+		}
+		
+		delete[] pDistances;
+		delete[] weights;
+	}
+
+	return bResult;
+}
+
Index: /cpp/frams/model/similarity/measure-mds-based.h
===================================================================
--- /cpp/frams/model/similarity/measure-mds-based.h	(revision 1044)
+++ /cpp/frams/model/similarity/measure-mds-based.h	(revision 1044)
@@ -0,0 +1,36 @@
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
+
+#ifndef _SIMIL_MEASURE_MDS_BASED_H
+#define _SIMIL_MEASURE_MDS_BASED_H
+
+#include "simil-measure.h"
+
+class SimilMeasureMDSBased : public SimilMeasure
+{
+public:
+	SimilMeasureMDSBased();
+	virtual ~SimilMeasureMDSBased(){};
+	virtual int setParams(std::vector<double> params)=0;
+	bool with_alignment;
+	bool save_matching;
+	int fixedZaxis;
+	int wMDS;
+protected:
+	double getDistance();
+	virtual void prepareData()=0;
+	virtual void beforeTransformation()=0;
+	virtual double distanceForTransformation()=0;
+	virtual double distanceWithoutAlignment()=0;
+	int getPartPositions();
+	bool computePartsPositionsByMDS();
+	virtual void copyMatching()=0;
+	virtual void cleanData()=0;
+	int m_iSmaller;
+	/// Positions of Parts of both of the compared structures. 
+	Pt3D *coordinates[2];
+};
+
+#endif
+
Index: /cpp/frams/model/similarity/simil-match.cpp
===================================================================
--- /cpp/frams/model/similarity/simil-match.cpp	(revision 1044)
+++ /cpp/frams/model/similarity/simil-match.cpp	(revision 1044)
@@ -0,0 +1,264 @@
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
+
+#include <assert.h>
+#include <stdio.h>
+#include "simil-match.h"
+
+/** Creates an empty matching for two objects of specified size.
+		@param Obj0Size Size of the first object. Must be positive.
+		@param Obj1Size Size of the second object. Must be positive.
+ */
+SimilMatching::SimilMatching(int Obj0Size, int Obj1Size)
+{
+	// assure that sizes of objects are positive
+	assert(Obj0Size > 0);
+	assert(Obj1Size > 0);
+
+	// create necessary vectors
+	m_apvMatched[0] = new std::vector<int>(Obj0Size);
+	m_apvMatched[1] = new std::vector<int>(Obj1Size);
+
+	// assure that vectors are created
+	assert(m_apvMatched[0] != NULL);
+	assert(m_apvMatched[1] != NULL);
+
+	// fill vectors with "unmatched" indicator
+	for (unsigned int i = 0; i < m_apvMatched[0]->size(); i++)
+	{
+		m_apvMatched[0]->operator[](i) = -1;
+	}
+	for (unsigned int i = 0; i < m_apvMatched[1]->size(); i++)
+	{
+		m_apvMatched[1]->operator[](i) = -1;
+	}
+}
+
+/** A copying constructor.
+		@param Source The object to be copied.
+ */
+SimilMatching::SimilMatching(const SimilMatching &Source)
+{
+	// copy the vectors of the actual matching
+	m_apvMatched[0] = new std::vector<int>(*(Source.m_apvMatched[0]));
+	m_apvMatched[1] = new std::vector<int>(*(Source.m_apvMatched[1]));
+
+	// assure that vectors are created
+	assert(m_apvMatched[0] != NULL);
+	assert(m_apvMatched[1] != NULL);
+}
+
+/** Destroys a matching object.
+ */
+SimilMatching::~SimilMatching()
+{
+	// delete vectors of matching
+	delete m_apvMatched[0];
+	delete m_apvMatched[1];
+}
+
+/** Gets size of the specified object.
+		@param Index of an object (must be 0 or 1).
+		@return Size of the object (in elements).
+ */
+int SimilMatching::getObjectSize(int Obj)
+{
+	// check parameter
+	assert((Obj == 0) || (Obj == 1));
+
+	// return the result
+	return m_apvMatched[Obj]->size();
+}
+
+/** Matches elements given by indices in the given objects.
+		@param Obj0 Index of the first object. Must be 0 or 1.
+		@param index0 Index of element in the first object. Must be a valid index
+		( >= 0 and < size of the object).
+		@param Obj1 Index of the second object. Must be 0 or 1 and different from Obj0.
+		@param Index1 index of element in the second object. Must be a valid index
+		( >= 0 and < size of the object).
+
+ */
+void SimilMatching::match(int Obj0, int Index0, int Obj1, int Index1)
+{
+	// check parameters of object 0
+	assert((Obj0 == 0) || (Obj0 == 1));
+	assert((Index0 >= 0) && (Index0 < (int)m_apvMatched[Obj0]->size()));
+	// check parameters of object 1
+	assert(((Obj1 == 0) || (Obj1 == 1)) && (Obj0 != Obj1));
+	assert((Index1 >= 0) && (Index1 < (int)m_apvMatched[Obj1]->size()));
+
+	// match given elements
+	// matching_Obj0(Index0) = Index1
+	m_apvMatched[Obj0]->operator[](Index0) = Index1;
+	// matching_Obj1(Index1) = Index0
+	m_apvMatched[Obj1]->operator[](Index1) = Index0;
+}
+
+/** Checks if the given element in the given object is already matched.
+		@param Obj Index of an object (must be 0 or 1).
+		@param Index Index of an element in the given object. Must be a valid index
+		( >=0 and < size of the object).
+		@return true if the given element is matched, false otherwise.
+ */
+bool SimilMatching::isMatched(int Obj, int Index)
+{
+	// check parameters
+	assert((Obj == 0) || (Obj == 1));
+	assert((Index >= 0) && (Index < (int)m_apvMatched[Obj]->size()));
+
+	// check if the element is matched
+	if (m_apvMatched[Obj]->operator[](Index) >= 0)
+	{
+		return true;
+	}
+	else
+	{
+		return false;
+	}
+}
+
+/** Gets index of the element thet is matched in the other object withe the element given
+		by parameters.
+		@param Obj Index of an object (must be 0 or 1).
+		@param Index Index of checked element in the given object.
+		@return Index of the element (in the other organism) that is matched with the given
+		element. WARNING! If the given element is not matched, the result may be smaller than 0
+		(check IsMatched() before using GetMatchedIndex()).
+ */
+int SimilMatching::getMatchedIndex(int Obj, int Index)
+{
+	// check parameters
+	assert((Obj == 0) || (Obj == 1));
+	assert((Index >= 0) && (Index < (int)m_apvMatched[Obj]->size()));
+
+	// return the index of the matched element
+	return m_apvMatched[Obj]->operator[](Index);
+}
+
+/** Checks if the matching is already full, i.e. if the smaller object already has all its
+		elements matched.
+		@return true if matching is full, false otherwise.
+ */
+bool SimilMatching::isFull()
+{
+	// assume that the matching is full
+	bool bResult = true;
+	// index of the smallest object
+	int nObj;
+
+	// find the smallest object (its index)
+	if (m_apvMatched[0]->size() < m_apvMatched[1]->size())
+	{
+		nObj = 0;
+	}
+	else
+	{
+		nObj = 1;
+	}
+
+	// check if all elements of the smallest object are matched
+	for (unsigned int nElem = 0; nElem < m_apvMatched[nObj]->size(); nElem++)
+	{
+		if (m_apvMatched[nObj]->operator[](nElem) < 0)
+		{
+			// if any element is not matched, the result is false
+			bResult = false;
+			break;
+		}
+	}
+
+	// return the result
+	return bResult;
+}
+
+/** Checks if the matching is empty (i.e. none of elements is matched).
+	@return true if matching is empty, otherwise - false.
+ */
+bool SimilMatching::isEmpty()
+{
+	// result - assume that matching is empty
+	bool bResult = true;
+
+	// matching is empty if either of objects has only unmatched elements
+	// so it may be first object 
+	int nObj = 0;
+	for (unsigned int nElem = 0; nElem < m_apvMatched[nObj]->size(); nElem++)
+	{
+		if (m_apvMatched[nObj]->operator[](nElem) >= 0)
+		{
+			// if any element of the object is matched (unmatched objects have (-1))
+			bResult = false;
+			break;
+		}
+	}
+
+	// return the result from the loop
+	return bResult;
+}
+
+/** Makes the matching completely empty. After a call to this method IsEmpty() should return true.
+ */
+void SimilMatching::empty()
+{
+	for (int iObj = 0; iObj < 2; iObj++) // a counter of objects
+	{
+		// for each object in the matching
+		for (unsigned int iElem = 0; iElem < m_apvMatched[iObj]->size(); iElem++) // a counter of objects' elements
+		{
+			// for each element iElem for the object iObj
+			// set it as unmatched (marker: -1)
+			m_apvMatched[iObj]->operator[](iElem) = -1;
+		}
+	}
+
+	// the exit condition
+	assert(isEmpty() == true);
+}
+
+/** Prints the current state of the matching
+ */
+void SimilMatching::printMatching()
+{
+	int nBigger;
+
+	// check which object is bigger
+	if (m_apvMatched[0]->size() >= m_apvMatched[1]->size())
+	{
+		nBigger = 0;
+	}
+	else
+	{
+		nBigger = 1;
+	}
+
+	// print first line - indices of objects
+	printf("[ ");
+	for (unsigned int i = 0; i < m_apvMatched[nBigger]->size(); i++)
+	{
+		printf("%2d ", i);
+	}
+	printf("]\n");
+
+	// print second line and third - indices of elements matched with elements of the objects
+	for (int nObj = 0; nObj < 2; nObj++)
+	{
+		// for both objects - print out lines of matched elements
+		printf("[ ");
+		for (unsigned int i = 0; i < m_apvMatched[nObj]->size(); i++)
+		{
+			if (isMatched(nObj, i))
+			{
+				// if the element is matched - print the index
+				printf("%2d ", getMatchedIndex(nObj, i));
+			}
+			else
+			{
+				// if the element is not matched - print "X"
+				printf(" X ");
+			}
+		}
+		printf("]\n");
+	}
+}
Index: /cpp/frams/model/similarity/simil-match.h
===================================================================
--- /cpp/frams/model/similarity/simil-match.h	(revision 1044)
+++ /cpp/frams/model/similarity/simil-match.h	(revision 1044)
@@ -0,0 +1,38 @@
+// This file is a part of Framsticks SDK.  http://www.framsticks.com/
+// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
+// See LICENSE.txt for details.
+
+#ifndef SIMILMATCHING_H
+#define SIMILMATCHING_H
+
+#include <vector>
+
+/** This class describes a mutually single-valued function between two sets of elements
+	(these sets are called objects). These sets may have different sizes, so this function
+	is mutually single-valued only for some subset of the bigger set.
+	This class is used while building a matching function between Parts of two Framsticks'
+	organisms (similarity measure computation).
+ */
+class SimilMatching
+{
+protected:
+	/** Array of pointers to two vectors. Each one stores indices of matched elements of
+		the other object. Value <0 means that an element is not matched yet. Sizes of these
+		vectors are sizes of objects themselves.
+	 */
+	std::vector<int> *m_apvMatched[2];
+public:
+	SimilMatching(int Obj0Size, int Obj1Size);
+	SimilMatching(const SimilMatching &Source);
+	~SimilMatching();
+	int getObjectSize(int Obj);
+	void match(int Obj0, int Index0, int Obj1, int Index1);
+	bool isMatched(int Obj, int Index);
+	int getMatchedIndex(int Obj, int index);
+	bool isFull();
+	bool isEmpty();
+	void empty();
+	void printMatching();
+};
+
+#endif
